"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompilationContextImpl = void 0;
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const SessionCompiler_1 = require("./SessionCompiler");
/** Implementation of {@link CompilationContext}. */
class CompilationContextImpl {
    constructor(baseDir = '.') {
        this._sourceFiles = [];
        this.generateReplicaSite = true;
        this.generateArchive = true;
        if (!fs.existsSync(baseDir) || !fs.lstatSync(baseDir).isDirectory())
            throw new Error(`${baseDir} is not a valid directory.`);
        this.baseDirectory = fs.realpathSync(baseDir);
        this._outputDir = path_1.default.resolve(this.baseDirectory, 'build');
    }
    get outputDirectory() {
        return this._outputDir;
    }
    get sourceFiles() {
        return this._sourceFiles;
    }
    outputDir(outputDir) {
        this._outputDir = path_1.default.resolve(this.baseDirectory, outputDir);
        return this;
    }
    source(filePath) {
        const realFilePath = fs.realpathSync(path_1.default.resolve(this.baseDirectory, filePath));
        const isFilePathIsDirectory = fs.lstatSync(realFilePath).isDirectory();
        if (isFilePathIsDirectory) {
            this._sourceFiles.push(...fs
                .readdirSync(realFilePath)
                .filter((file) => file.endsWith('.json'))
                .map((json) => fs.realpathSync(path_1.default.resolve(realFilePath, json))));
        }
        else {
            this._sourceFiles.push(realFilePath);
        }
        return this;
    }
    sources(...paths) {
        paths.forEach((filePath) => this.source(filePath));
        return this;
    }
    compileSession() {
        return __awaiter(this, void 0, void 0, function* () {
            yield (yield SessionCompiler_1.SessionCompiler.create(this)).compile();
        });
    }
}
exports.CompilationContextImpl = CompilationContextImpl;
